// Generated by CoffeeScript 1.9.1
var WebSocketServer;

WebSocketServer = require('ws').Server;

module.exports = function(opts) {
  var clients, id, server, wss;
  if (opts == null) {
    opts = {};
  }
  if (typeof opts === 'function') {
    server = opts;
    opts = {
      server: server
    };
  }
  if (opts.server == null) {
    if (opts.port == null) {
      opts.port = 3456;
    }
  }
  if (opts.path == null) {
    opts.path = '/_bebop';
  }
  wss = new WebSocketServer(opts);
  clients = {};
  id = 0;
  wss.on('connection', function(ws) {
    id += 1;
    ws.id = id;
    clients[ws.id] = ws;
    return ws.on('close', function() {
      return delete clients[ws.id];
    });
  });
  return {
    server: wss,
    close: function() {
      for (id in clients) {
        clients[id].close();
        delete clients[id];
      }
      return wss.close();
    },
    send: function(message) {
      var err, results;
      results = [];
      for (id in clients) {
        try {
          results.push(clients[id].send(JSON.stringify(message)));
        } catch (_error) {
          err = _error;
          results.push(console.error(err.stack));
        }
      }
      return results;
    },
    modified: function(filename) {
      return this.send({
        type: 'modified',
        filename: filename
      });
    }
  };
};

//# sourceMappingURL=websocket.js.map
